/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nic_othercommands.js
 * 	Definition of other commands that are not available internaly in the
 * 	browser (see FCKNamedCommand).
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-15 13:28:09
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// ### General Dialog Box Commands.
var NICDialogCommand = function( name, title, url, width, height, getStateFunction, getStateParam )
{
	this.Name	= name ;
	this.Title	= title ;
	this.Url	= url ;
	this.Width	= width ;
	this.Height	= height ;
	
	this.GetStateFunction	= getStateFunction ;
	this.GetStateParam		= getStateParam ;
}

NICDialogCommand.prototype.Execute = function()
{
	NICDialog.OpenDialog( 'NICDialog_' + this.Name , this.Title, this.Url, this.Width, this.Height ) ;
}

NICDialogCommand.prototype.GetState = function()
{
	if ( this.GetStateFunction )
		return this.GetStateFunction( this.GetStateParam ) ;
	else
		return NIC_TRISTATE_OFF ;
}

// Generic Undefined command (usually used when a command is under development).
var NICUndefinedCommand = function()
{
	this.Name = 'Undefined' ;
}

NICUndefinedCommand.prototype.Execute = function()
{
	alert( NICLang.NotImplemented ) ;
} 

NICUndefinedCommand.prototype.GetState = function()
{
	return NIC_TRISTATE_OFF ;
}

// ### FontName
var NICFontNameCommand = function() 
{
	this.Name = 'FontName' ;
}

NICFontNameCommand.prototype.Execute = function( fontName )
{
	if (fontName == null || fontName == "")
	{
		// TODO: Remove font name attribute.
	}
	else
		NIC.ExecuteNamedCommand( 'FontName', fontName ) ;
}

NICFontNameCommand.prototype.GetState = function()
{
	return NIC.GetNamedCommandValue( 'FontName' ) ;
}

// ### FontSize
var NICFontSizeCommand = function() 
{
	this.Name = 'FontSize' ;
}

NICFontSizeCommand.prototype.Execute = function( fontSize )
{
	if ( typeof( fontSize ) == 'string' ) fontSize = parseInt(fontSize) ;
	
	if ( fontSize == null || fontSize == '' )
	{
		// TODO: Remove font size attribute (Now it works with size 3. Will it work forever?)
		NIC.ExecuteNamedCommand( 'FontSize', 3 ) ;
	}
	else
		NIC.ExecuteNamedCommand( 'FontSize', fontSize ) ;
}

NICFontSizeCommand.prototype.GetState = function()
{
	return NIC.GetNamedCommandValue( 'FontSize' ) ;
}

// ### FormatBlock
var NICFormatBlockCommand = function() 
{
	this.Name = 'FormatBlock' ;
}

NICFormatBlockCommand.prototype.Execute = function( formatName )
{
	if ( formatName == null || formatName == '' )
		NIC.ExecuteNamedCommand( 'FormatBlock', '<P>' ) ;
	else
		NIC.ExecuteNamedCommand( 'FormatBlock', '<' + formatName + '>' ) ;
}

NICFormatBlockCommand.prototype.GetState = function()
{
	return NIC.GetNamedCommandValue( 'FormatBlock' ) ;
}

// ### Preview
var NICPreviewCommand = function() 
{
	this.Name = 'Preview' ;
}

NICPreviewCommand.prototype.Execute = function()
{
     NIC.Preview() ;
}

NICPreviewCommand.prototype.GetState = function()
{
	return NIC_TRISTATE_OFF ;
}

// ### Save
var NICSaveCommand = function() 
{
	this.Name = 'Save' ;
}

NICSaveCommand.prototype.Execute = function()
{
	// Get the linked field form.
	var oForm = NIC.LinkedField.form ;
	
	// Submit the form.
	oForm.submit() ;
}

NICSaveCommand.prototype.GetState = function()
{
	return NIC_TRISTATE_OFF ;
}

// ### NewPage
var NICNewPageCommand = function() 
{
	this.Name = 'NewPage' ;
}

NICNewPageCommand.prototype.Execute = function()
{
	NIC.SetHTML( NICBrowserInfo.IsGecko ? '&nbsp;' : '' ) ;
}

NICNewPageCommand.prototype.GetState = function()
{
	return NIC_TRISTATE_OFF ;
}

// ### Source button
var NICSourceCommand = function()
{
	this.Name = "Source" ;
}

NICSourceCommand.prototype.Execute = function()
{
     NIC.SwitchEditMode() ;
}

NICSourceCommand.prototype.GetState = function()
{
	return ( NIC.EditMode == NIC_EDITMODE_WYSIWYG ? NIC_TRISTATE_OFF : NIC_TRISTATE_ON ) ;
}
