/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nicstylecommand.js
 * 	FCKStyleCommand Class: represents the "Style" command.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-11-22 11:07:24
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var NICStyleCommand = function()
{
	this.Name = 'Style' ;

	// Load the Styles defined in the XML file.
	this.StylesLoader = new NICStylesLoader() ;
	this.StylesLoader.Load( NICConfig.StylesXmlPath ) ;
	this.Styles = this.StylesLoader.Styles ;
}

NICStyleCommand.prototype.Execute = function( styleName, styleComboItem )
{
	if ( styleComboItem.Selected )
		styleComboItem.Style.RemoveFromSelection() ;
	else
		styleComboItem.Style.ApplyToSelection() ;

	NIC.Focus() ;
	
	NIC.Events.FireEvent( "OnSelectionChange" ) ;
}

NICStyleCommand.prototype.GetState = function()
{
	var oSelection = NIC.EditorDocument.selection ;
	
	if ( NICSelection.GetType() == 'Control' )
	{
		var e = NICSelection.GetSelectedElement() ;
			if ( e )
				return this.StylesLoader.StyleGroups[ e.tagName ] ? NIC_TRISTATE_OFF : NIC_TRISTATE_DISABLED ;
			else
				NIC_TRISTATE_OFF ;
	}
	else
		return NIC_TRISTATE_OFF ;
}

NICStyleCommand.prototype.GetActiveStyles = function()
{
	var aActiveStyles = new Array() ;
	
	if ( NICSelection.GetType() == 'Control' )
		this._CheckStyle( NICSelection.GetSelectedElement(), aActiveStyles, false ) ;
	else
		this._CheckStyle( NICSelection.GetParentElement(), aActiveStyles, true ) ;
		
	return aActiveStyles ;
}

NICStyleCommand.prototype._CheckStyle = function( element, targetArray, checkParent )
{
	if ( ! element )
		return ;

	if ( element.nodeType == 1 )
	{
		var aStyleGroup = this.StylesLoader.StyleGroups[ element.tagName ] ;
		if ( aStyleGroup )
		{
			for ( var i = 0 ; i < aStyleGroup.length ; i++ )
			{
				if ( aStyleGroup[i].IsEqual( element ) )
					targetArray[ targetArray.length ] = aStyleGroup[i] ;
			}		
		}
	}
	
	if ( checkParent )
		this._CheckStyle( element.parentNode, targetArray, checkParent ) ;
}
