/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nic_1.js
 * 	This is the first part of the "FCK" object creation. This is the main
 * 	object that represents an editor instance.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-20 12:47:38
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

NIC.Events	= new NICEvents( NIC ) ;
NIC.Toolbar	= null ;

NIC.StartEditor = function()
{
	// Get the editor's window and document (DOM)
	this.EditorWindow	= window.frames[ 'eEditorArea' ] ;
	this.EditorDocument	= this.EditorWindow.document ;

	// TODO: Wait stable version and remove the following commented lines.
	// The Base Path of the editor is saved to rebuild relative URL (IE issue).
//	this.BaseUrl = this.EditorDocument.location.protocol + '//' + this.EditorDocument.location.host ;

	// Set the editor's startup contents
	this.SetHTML( NICTools.GetLinkedFieldValue() ) ;
	
	// Set the editor area CSS file.
	NICTools.AppendStyleSheet( this.EditorDocument, NICConfig.EditorAreaCSS ) ;

	// Attach the editor to the form onsubmit event
	NICTools.AttachToLinkedFieldFormSubmit( this.UpdateLinkedField ) ;
	
	// Initialize the default browser behaviors (browser specific).
	this.InitializeBehaviors() ;
}

NIC.SetStatus = function( newStatus )
{
	this.Status = newStatus ;
	
	if ( newStatus == NIC_STATUS_ACTIVE )
	{
		// Force the focus in the window to go to the editor.
		window.onfocus = window.document.body.onfocus = NIC.Focus ;
		
		// Force the focus in the editor.
		if ( NICConfig.StartupFocus )
			NIC.Focus() ;
	
	
		
		if ( NICBrowserInfo.IsIE )
			NICScriptLoader.AddScript( 'js/niceditorcode_ie_2.js' ) ;
		else
			NICScriptLoader.AddScript( 'js/niceditorcode_gecko_2.js' ) ;
			
	}
	
	this.Events.FireEvent( 'OnStatusChange', newStatus ) ;
	if ( this.OnStatusChange ) this.OnStatusChange( newStatus ) ;
	
}

NIC.GetHTML = function()
{
	if ( NIC.EditMode == NIC_EDITMODE_WYSIWYG )
	{
		// TODO: Wait stable version and remove the following commented lines.
//		if ( NICBrowserInfo.IsIE )
//			NIC.CheckRelativeLinks() ;

		return this.EditorDocument.body.innerHTML ;
	}
	else
		return document.getElementById('eSourceField').value ;
}

NIC.GetXHTML = function()
{
	var bSource = ( NIC.EditMode == NIC_EDITMODE_SOURCE ) ;
	
	if ( bSource )
		this.SwitchEditMode() ;

	// TODO: Wait stable version and remove the following commented lines.
//	if ( NICBrowserInfo.IsIE )
//		NIC.CheckRelativeLinks() ;
	
	var sXHTML = NICXHtml.GetXHTML( this.EditorDocument.body ) ;
	
	if ( bSource )
		this.SwitchEditMode() ;
		
	return sXHTML ;
}

NIC.UpdateLinkedField = function()
{
	if ( NICConfig.EnableXHTML )
		NICTools.SetLinkedFieldValue( NIC.GetXHTML() ) ;
	else
		NICTools.SetLinkedFieldValue( NIC.GetHTML() ) ;
}

NIC.ShowContextMenu = function( x, y )
{
	if ( this.Status != NIC_STATUS_COMPLETE ) 
		return ;
		
	NICContextMenu.Show( x, y ) ;
	this.Events.FireEvent( "OnContextMenu" ) ;
}

