/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nic_2_gecko.js
 * 	This is the second part of the "FCK" object creation. This is the main
 * 	object that represents an editor instance.
 * 	(Gecko specific implementations)
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-20 14:04:19
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// GetNamedCommandState overload for Gecko.
NIC._BaseGetNamedCommandState = NIC.GetNamedCommandState ;
NIC.GetNamedCommandState = function( commandName )
{
	switch ( commandName )
	{
		case 'Unlink' :
			return NICSelection.HasAncestorNode('A') ? NIC_TRISTATE_OFF : NIC_TRISTATE_DISABLED ;
		default :
			return NIC._BaseGetNamedCommandState( commandName ) ;
	}
}

// Named commands to be handled by this browsers specific implementation.
NIC.RedirectNamedCommands = 
{
	Print	: true,
	Paste	: true,
	Cut		: true,
	Copy	: true 
}

// ExecuteNamedCommand overload for Gecko.
NIC.ExecuteRedirectedNamedCommand = function( commandName, commandParameter )
{
	switch ( commandName )
	{
		case 'Print' :
			NIC.EditorWindow.print() ;
			break ;
		case 'Paste' :
			try			{ if ( NIC.Paste() ) NIC._BaseExecuteNamedCommand( 'Paste' ) ; }
			catch (e)	{ alert( NICLang.PasteErrorPaste ) ; }
			break ;
		case 'Cut' :
			try			{ NIC._BaseExecuteNamedCommand( 'Cut' ) ; }
			catch (e)	{ alert( NICLang.PasteErrorCut ) ; }
			break ;
		case 'Copy' :
			try			{ NIC._BaseExecuteNamedCommand( 'Copy' ) ; }
			catch (e)	{ alert( NICLang.PasteErrorCopy ) ; }
			break ;
		default :
			NIC.ExecuteNamedCommand( commandName, commandParameter ) ;
	}
}

NIC.AttachToOnSelectionChange = function( functionPointer )
{
	this.Events.AttachEvent( 'OnSelectionChange', functionPointer ) ;
}

NIC.Paste = function()
{
	if ( NICConfig.ForcePasteAsPlainText )
	{
		NIC.PasteAsPlainText() ;	
		return false ;
	}
	else if ( NICConfig.AutoDetectPasteFromWord && NICBrowserInfo.IsIE55OrMore )
	{
		var sHTML = NIC.GetClipboardHTML() ;
		var re = /<\w[^>]* class="?MsoNormal"?/gi ;
		if ( re.test( sHTML ) )
		{
			if ( confirm( NICLang["PasteWordConfirm"] ) )
			{
				NIC.CleanAndPaste( sHTML ) ;
				return false ;
			}
		}
	}
	else
		return true ;
}

//**
// NIC.InsertHtml: Inserts HTML at the current cursor location. Deletes the
// selected content if any.
NIC.InsertHtml = function( html )
{
	// Delete the actual selection.
	var oSel = NICSelection.Delete() ;
	
//	var oContainer	= oSel.getRangeAt(0).startContainer ;
//	var iOffSet		= oSel.getRangeAt(0).startOffset ;
	
	// Get the first available range.
	var oRange = oSel.getRangeAt(0) ;
	
//	var oRange = this.EditorDocument.createRange() ;
//	oRange.setStart( oContainer, iOffSet ) ;
//	oRange.setEnd( oContainer, iOffSet ) ;
	
	// Create a fragment with the input HTML.
	var oFragment = oRange.createContextualFragment( html ) ;
	
	// Get the last available node.
	var oLastNode = oFragment.lastChild ;

	// Insert the fragment in the range.
	oRange.insertNode(oFragment) ;
	
	// Set the cursor after the inserted fragment.
	oRange.setEndAfter( oLastNode ) ;
	oRange.setStartAfter( oLastNode ) ;
	
	oSel.removeAllRanges() ;
	oSel = NIC.EditorWindow.getSelection() ;
	oSel.addRange( oRange ) ;
		
	this.Focus() ;
}

NIC.InsertElement = function( element )
{
	// Deletes the actual selection.
	var oSel = NICSelection.Delete() ;
	
	// Gets the first available range.
	var oRange = oSel.getRangeAt(0) ;
	
	// Inserts the element in the range.
	oRange.insertNode( element ) ;
	
	// Set the cursor after the inserted fragment.
	oRange.setEndAfter( element ) ;
	oRange.setStartAfter( element ) ;

	this.Focus() ;
}

NIC.PasteAsPlainText = function()
{
	// TODO: Implement the "Paste as Plain Text" code.
	
	NICDialog.OpenDialog( 'NICDialog_Paste', NICLang.PasteAsText, 'dialog/nic_paste.html', 400, 330, 'PlainText' ) ;
	
/*
	var sText = NICTools.HTMLEncode( clipboardData.getData("Text") ) ;
	sText = sText.replace( /\n/g, '<BR>' ) ;
	this.InsertHtml( sText ) ;	
*/
}

NIC.PasteFromWord = function()
{
	// TODO: Implement the "Paste as Plain Text" code.
	
	NICDialog.OpenDialog( 'NICDialog_Paste', NICLang.PasteFromWord, 'dialog/nic_paste.html', 400, 330, 'Word' ) ;

//	NIC.CleanAndPaste( NIC.GetClipboardHTML() ) ;
}

NIC.GetClipboardHTML = function()
{
	return '' ;
}

NIC.CreateLink = function( url )
{	
	NIC.ExecuteNamedCommand( 'Unlink' ) ;
	
	if ( url.length > 0 )
	{
		// Generate a temporary name for the link.
		var sTempUrl = 'javascript:void(0);/*' + ( new Date().getTime() ) + '*/' ;
		
		// Use the internal "CreateLink" command to create the link.
		NIC.ExecuteNamedCommand( 'CreateLink', sTempUrl ) ;

		// Retrieve the just created link using XPath.
		var oLink = document.evaluate("//a[@href='" + sTempUrl + "']", this.EditorDocument.body, null, 9, null).singleNodeValue ;
		
		if ( oLink )
		{
			oLink.href = url ;
			return oLink ;
		}
	}
}

