/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: niccommands.js
 * 	Define all commands available in the editor.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-19 22:51:46
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var NICCommands = NIC.Commands = new Object() ;
NICCommands.LoadedCommands = new Object() ;

NICCommands.RegisterCommand = function( commandName, command )
{
	this.LoadedCommands[ commandName ] = command ;
}

NICCommands.GetCommand = function( commandName )
{
	var oCommand = NICCommands.LoadedCommands[ commandName ] ;
	
	if ( oCommand )
		return oCommand ;

	switch ( commandName )
	{
		case 'Link'			: oCommand = new NICDialogCommand( 'Link'		, NICLang.DlgLnkWindowTitle		, 'dialog/nic_link.html'		, 400, 330, NIC.GetNamedCommandState, 'CreateLink' ) ; break ;
		case 'About'		: oCommand = new NICDialogCommand( 'About'		, NICLang.About					, 'dialog/nic_about.html'		, 400, 330 ) ; break ;

		case 'Find'			: oCommand = new NICDialogCommand( 'Find'		, NICLang.DlgFindTitle			, 'dialog/nic_find.html'		, 340, 170 ) ; break ;
		case 'Replace'		: oCommand = new NICDialogCommand( 'Replace'	, NICLang.DlgReplaceTitle		, 'dialog/nic_replace.html'		, 340, 200 ) ; break ;

		case 'Image'		: oCommand = new NICDialogCommand( 'Image'		, NICLang.DlgImgTitle			, 'dialog/nic_image.html'		, 450, 400, NIC.GetNamedCommandState, 'InsertImage' ) ; break ;
		case 'SpecialChar'	: oCommand = new NICDialogCommand( 'SpecialChar', NICLang.DlgSpecialCharTitle	, 'dialog/nic_specialchar.html'	, 400, 300, NIC.GetNamedCommandState, 'InsertImage' ) ; break ;
		case 'Smiley'		: oCommand = new NICDialogCommand( 'Smiley'		, NICLang.DlgSmileyTitle		, 'dialog/nic_smiley.html'		, NICConfig.SmileyWindowWidth, NICConfig.SmileyWindowHeight, NIC.GetNamedCommandState, 'InsertImage' ) ; break ;
		case 'Table'		: oCommand = new NICDialogCommand( 'Table'		, NICLang.DlgTableTitle			, 'dialog/nic_table.html'		, 400, 250 ) ; break ;
		case 'TableProp'	: oCommand = new NICDialogCommand( 'Table'		, NICLang.DlgTableTitle			, 'dialog/nic_table.html?Parent', 400, 250 ) ; break ;
		case 'TableCellProp': oCommand = new NICDialogCommand( 'TableCell'	, NICLang.DlgCellTitle			, 'dialog/nic_tablecell.html'	, 500, 250 ) ; break ;

		case 'Style'		: oCommand = new NICStyleCommand() ; break ;

		case 'FontName'		: oCommand = new NICFontNameCommand() ; break ;
		case 'FontSize'		: oCommand = new NICFontSizeCommand() ; break ;
		case 'FontFormat'	: oCommand = new NICFormatBlockCommand() ; break ;

		case 'Source'		: oCommand = new NICSourceCommand() ; break ;
		case 'Preview'		: oCommand = new NICPreviewCommand() ; break ;
		case 'Save'			: oCommand = new NICSaveCommand() ; break ;
		case 'NewPage'		: oCommand = new NICNewPageCommand() ; break ;

		case 'TextColor'	: oCommand = new NICTextColorCommand('ForeColor') ; break ;
		case 'BGColor'		: oCommand = new NICTextColorCommand('BackColor') ; break ;

		case 'PasteText'	: oCommand = new NICPastePlainTextCommand() ; break ;
		case 'PasteWord'	: oCommand = new NICPasteWordCommand() ; break ;

		case 'TableInsertRow'		: oCommand = new NICTableCommand('TableInsertRow') ; break ;
		case 'TableDeleteRows'		: oCommand = new NICTableCommand('TableDeleteRows') ; break ;
		case 'TableInsertColumn'	: oCommand = new NICTableCommand('TableInsertColumn') ; break ;
		case 'TableDeleteColumns'	: oCommand = new NICTableCommand('TableDeleteColumns') ; break ;
		case 'TableInsertCell'		: oCommand = new NICTableCommand('TableInsertCell') ; break ;
		case 'TableDeleteCells'		: oCommand = new NICTableCommand('TableDeleteCells') ; break ;
		case 'TableMergeCells'		: oCommand = new NICTableCommand('TableMergeCells') ; break ;
		case 'TableSplitCell'		: oCommand = new NICTableCommand('TableSplitCell') ; break ;

		// Generic Undefined command (usually used when a command is under development).
		case 'Undefined'	: oCommand = new NICUndefinedCommand() ; break ;
		
		// By default we assume that it is a named command.
		default:
			if ( NICRegexLib.NamedCommands.test( commandName ) )
				oCommand = new NICNamedCommand( commandName ) ;
			else
			{
				alert( NICLang.UnknownCommand.replace( /%1/g, commandName ) ) ;
				return ;
			}
	}
	
	NICCommands.LoadedCommands[ commandName ] = oCommand ;
	
	return oCommand ;
}

