/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: niclanguagemanager.js
 * 	Defines the FCKLanguageManager object that is used for language 
 * 	operations.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-17 08:12:36
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

NICLanguageManager.GetActiveLanguage = function()
{
	if ( NICConfig.AutoDetectLanguage )
	{
		var sUserLang ;
		
		// IE accepts "navigator.userLanguage" while Gecko "navigator.language".
		if ( navigator.userLanguage )
			sUserLang = navigator.userLanguage.toLowerCase() ;
		else if ( navigator.language )
			sUserLang = navigator.language.toLowerCase() ;
		else
		{
			// Firefox 1.0 PR has a bug: it doens't support the "language" property.
			return NICConfig.DefaultLanguage ;
		}

		NICDebug.Output( 'Navigator Language = ' + sUserLang ) ;
		
		// Some language codes are set in 5 characters, 
		// like "pt-br" for Brasilian Portuguese.
		if ( sUserLang.length >= 5 )
		{
			sUserLang = sUserLang.substr(0,5) ;
			if ( this.AvailableLanguages[sUserLang] ) return sUserLang ;
		}
		
		// If the user's browser is set to, for example, "pt-br" but only the 
		// "pt" language file is available then get that file.
		if ( sUserLang.length >= 2 )
		{
			sUserLang = sUserLang.substr(0,2) ;
			if ( this.AvailableLanguages[sUserLang] ) return sUserLang ;
		}
	}
	
	return this.DefaultLanguage ;
}

NICLanguageManager.TranslateElements = function( targetDocument, tag, propertyToSet )
{
	var aInputs = targetDocument.getElementsByTagName(tag) ;
	for ( var i = 0 ; i < aInputs.length ; i++ )
	{
		var oAtt = aInputs[i].attributes['nicLang'] ;
		if ( oAtt )
		{
			var s = NICLang[ oAtt.value ] ;
			if ( s ) 
				eval( 'aInputs[i].' + propertyToSet + ' = s' ) ;
		}
	}
}

NICLanguageManager.TranslatePage = function( targetDocument )
{
	this.TranslateElements( targetDocument, 'INPUT', 'value' ) ;
	this.TranslateElements( targetDocument, 'SPAN', 'innerHTML' ) ;
	this.TranslateElements( targetDocument, 'LABEL', 'innerHTML' ) ;
	this.TranslateElements( targetDocument, 'OPTION', 'innerHTML' ) ;
}

if ( NICLanguageManager.AvailableLanguages[ NICConfig.DefaultLanguage ] )
	NICLanguageManager.DefaultLanguage = NICConfig.DefaultLanguage ;
else
	NICLanguageManager.DefaultLanguage = 'en' ;

NICLanguageManager.ActiveLanguage = new Object() ;
NICLanguageManager.ActiveLanguage.Code = NICLanguageManager.GetActiveLanguage() ;
NICLanguageManager.ActiveLanguage.Name = NICLanguageManager.AvailableLanguages[ NICLanguageManager.ActiveLanguage.Code ] ;

NIC.Language = NICLanguageManager ;


// Load the language file and start the editor.
LoadLanguageFile() ;
