/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nictoolbarset.js
 * 	Defines the FCKToolbarSet object that is used to load and draw the 
 * 	toolbar.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-11-23 19:53:19
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var NICToolbarSet = NIC.ToolbarSet = new Object() ;

document.getElementById( 'ExpandHandle' ).title		= NICLang.ToolbarExpand ;
document.getElementById( 'CollapseHandle' ).title	= NICLang.ToolbarCollapse ;

NICToolbarSet.Toolbars = new Array() ;

NICToolbarSet.Expand = function()
{
	document.getElementById( 'Collapsed' ).style.display = 'none' ;
	document.getElementById( 'Expanded' ).style.display = '' ;
	
	if ( ! NICBrowserInfo.IsIE )
	{
		// I had to use "setTimeout" because Gecko was not responding in a right
		// way when calling window.onresize() directly.
		window.setTimeout( "window.onresize()", 1 ) ;
	}
}

NICToolbarSet.Collapse = function()
{
	document.getElementById( 'Collapsed' ).style.display = '' ;
	document.getElementById( 'Expanded' ).style.display = 'none' ;
	
	if ( ! NICBrowserInfo.IsIE )
	{
		// I had to use "setTimeout" because Gecko was not responding in a right
		// way when calling window.onresize() directly.
		window.setTimeout( "window.onresize()", 1 ) ;
	}
}

NICToolbarSet.Restart = function()
{
	if ( !NICConfig.ToolbarCanCollapse || NICConfig.ToolbarStartExpanded )
		this.Expand() ;
	else
		this.Collapse() ;
	
	document.getElementById( 'CollapseHandle' ).style.display = NICConfig.ToolbarCanCollapse ? '' : 'none' ;
}

NICToolbarSet.Load = function( toolbarSetName )
{
	this.DOMElement = document.getElementById( 'eToolbar' ) ;
	
	var ToolbarSet = NICConfig.ToolbarSets[toolbarSetName] ;
	
	if (! ToolbarSet)
	{
		alert( NICLang.UnknownToolbarSet.replace( /%1/g, toolbarSetName ) ) ;
		return ;
	}
	
	this.Toolbars = new Array() ;
	
	for ( var x = 0 ; x < ToolbarSet.length ; x++ ) 
	{
		var oToolbar = new NICToolbar() ;
		
		for ( var j = 0 ; j < ToolbarSet[x].length ; j++ ) 
		{
			var sItem = ToolbarSet[x][j] ;
			
			if ( sItem == '-')
				oToolbar.AddSeparator() ;
			else
			{
				var oItem = NICToolbarItems.GetItem( sItem ) ;
				if ( oItem )
					oToolbar.AddItem( oItem ) ;
			}
		}
		
		oToolbar.AddTerminator() ;
		
		this.Toolbars[ this.Toolbars.length ] = oToolbar ;
	}
	
	this.Redraw() ;
}

NICToolbarSet.Redraw = function()
{
}

NICToolbarSet.RefreshItemsState = function()
{
	
	for ( var i = 0 ; i < NICToolbarSet.Toolbars.length ; i++ )
	{
		var oToolbar = NICToolbarSet.Toolbars[i] ;
		for ( var j = 0 ; j < oToolbar.Items.length ; j++ )
		{
			oToolbar.Items[j].RefreshState() ;
		}
	}
}

