/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nicconfig.js
 * 	Editor configuration settings.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-17 08:14:33
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// Custom Configurations (leave blank to ignore)
NICConfig.CustomConfigurationsPath = '' ;

// Style File to be used in the editable area.
NICConfig.EditorAreaCSS = NICConfig.BasePath + 'css/nic_editorarea.css' ;

// Enables the debug window
NICConfig.Debug = false ;

// Set the path for the skin files to use.
NICConfig.SkinPath = NICConfig.BasePath + 'skins/default/' ;

NICConfig.PluginsPath = NICConfig.BasePath + 'plugins/' ;

// Language settings
NICConfig.AutoDetectLanguage = true ;
NICConfig.DefaultLanguage    = 'en' ;

// Enable XHTML support
NICConfig.EnableXHTML		= true ;
NICConfig.EnableSourceXHTML	= true ;

// Tells Gecko browsers to use SPAN instead of <B>, <I> and <U>.
NICConfig.GeckoUseSPAN = true ;

// Force the editor to get the focus on startup (page load).
NICConfig.StartupFocus = true ;

// Cut and Paste options
NICConfig.ForcePasteAsPlainText	= false ;

NICConfig.ForceSimpleAmpersand = false ;

NICConfig.TabSpaces = 0 ;

// When the user presses <ENTER> inserts a <BR> tag instead of a <P> (on IE).
NICConfig.UseBROnCarriageReturn	= false ;

// Link: Target Windows
NICConfig.LinkShowTargets = true ;
NICConfig.LinkTargets = '_blank;_parent;_self;_top' ;
NICConfig.LinkDefaultTarget = '' ;

NICConfig.ToolbarStartExpanded	= true ;
NICConfig.ToolbarCanCollapse	= true ;

//##
//## Toolbar Buttons Sets
//##
NICConfig.ToolbarSets["Default"] = [
	['Source','-','Save','NewPage','Preview'],
	['Cut','Copy','Paste','PasteText','PasteWord','-','Print'],
	['Undo','Redo','-','Find','Replace','-','SelectAll','RemoveFormat'],
	['Bold','Italic','Underline','StrikeThrough','-','Subscript','Superscript'],
	['OrderedList','UnorderedList','-','Outdent','Indent'],
	['JustifyLeft','JustifyCenter','JustifyRight','JustifyFull'],
	['Link','Unlink'],
	['Image','Table','Rule','SpecialChar','Smiley'],
	['Style','FontFormat','FontName','FontSize'],
	['TextColor','BGColor'],
	['About']
] ;
NICConfig.ToolbarSets["Basic"] = [
	['Bold','Italic','-','OrderedList','UnorderedList','-','Link','Unlink','-','About']
] ;

// Font Colors
NICConfig.FontColors = '000000,993300,333300,003300,003366,000080,333399,333333,800000,FF6600,808000,808080,008080,0000FF,666699,808080,FF0000,FF9900,99CC00,339966,33CCCC,3366FF,800080,999999,FF00FF,FFCC00,FFFF00,00FF00,00FFFF,00CCFF,993366,C0C0C0,FF99CC,FFCC99,FFFF99,CCFFCC,CCFFFF,99CCFF,CC99FF,FFFFFF' ;

// Font Combos
NICConfig.FontNames		= 'Arial;Comic Sans MS;Courier New;Tahoma;Times New Roman;Verdana' ;
NICConfig.FontSizes		= '1/xx-small;2/x-small;3/small;4/medium;5/large;6/x-large;7/xx-large' ;
NICConfig.FontFormats	= 'p;div;pre;address;h1;h2;h3;h4;h5;h6' ;

NICConfig.StylesXmlPath	= '../nicstyles.xml' ;

// Link Browsing
NICConfig.LinkBrowser = true ;
NICConfig.LinkBrowserURL = NICConfig.BasePath + "filemanager/browser/default/browser.html?Connector=connectors/asp/connector.asp" ;
//NICConfig.LinkBrowserURL = NICConfig.BasePath + "filemanager/browser/default/browser.html?Connector=connectors/asp/connector.asp&ServerPath=/CustomFiles/" ;
//NICConfig.LinkBrowserURL = NICConfig.BasePath + "filemanager/browser/default/browser.html?Connector=connectors/aspx/connector.aspx" ;
//NICConfig.LinkBrowserURL = NICConfig.BasePath + "filemanager/browser/default/browser.html?Connector=connectors/php/connector.php" ;
NICConfig.LinkBrowserWindowWidth	= screen.width * 0.7 ;	// 70%
NICConfig.LinkBrowserWindowHeight	= screen.height * 0.7 ;	// 70%

// Link Upload
NICConfig.LinkUpload = false ;
NICConfig.LinkUploadURL = NICConfig.BasePath + "filemanager/upload/aspx/upload.aspx" ;
NICConfig.LinkUploadWindowWidth		= 300 ;
NICConfig.LinkUploadWindowHeight	= 150 ;
NICConfig.LinkUploadAllowedExtensions	= "*" ;		// * or empty for all
NICConfig.LinkUploadDeniedExtensions	= ".exe .asp .php .aspx .js .cfm .dll" ;	// empty for none

// Image Browsing
NICConfig.ImageBrowser = true ;
NICConfig.ImageBrowserURL = NICConfig.BasePath + "filemanager/browser/default/browser.html?Type=Image&Connector=connectors/asp/connector.asp" ;
//NICConfig.ImageBrowserURL = NICConfig.BasePath + "filemanager/browser/default/browser.html?Type=Image&Connector=connectors/aspx/connector.aspx" ;
//NICConfig.ImageBrowserURL = NICConfig.BasePath + "filemanager/browser/default/browser.html?Type=Image&Connector=connectors/php/connector.php" ;
NICConfig.ImageBrowserWindowWidth  = screen.width * 0.7 ;	// 70% ;
NICConfig.ImageBrowserWindowHeight = screen.height * 0.7 ;	// 70% ;

// Smiley Dialog
NICConfig.SmileyPath	= NICConfig.BasePath + "images/smiley/msn/" ;
NICConfig.SmileyImages	= ["regular_smile.gif","sad_smile.gif","wink_smile.gif","teeth_smile.gif","confused_smile.gif","tounge_smile.gif","embaressed_smile.gif","omg_smile.gif","whatchutalkingabout_smile.gif","angry_smile.gif","angel_smile.gif","shades_smile.gif","devil_smile.gif","cry_smile.gif","lightbulb.gif","thumbs_down.gif","thumbs_up.gif","heart.gif","broken_heart.gif","kiss.gif","envelope.gif"] ;
NICConfig.SmileyColumns = 8 ;
NICConfig.SmileyWindowWidth		= 320 ;
NICConfig.SmileyWindowHeight	= 240 ;
