<?php
//******************************************************************************************************
//	Name: ubr_finished.php
//	Revision: 3.8
//	Date: 9:57 PM October 15, 2009
//	Link: http://uber-uploader.sourceforge.net
//	Developer: Peter Schmandra
//	Description: Show successful file uploads.
//
//	Copyright (C) 2009  Peter Schmandra
//
//	This file is part of Uber-Uploader.
//
//	Uber-Uploader is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	Uber-Uploader is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with Uber-Uploader. If not, see http://www.gnu.org/licenses/.
//
//***************************************************************************************************************

//***************************************************************************************************************
// The following possible query string formats are assumed
//
// 1. ?upload_id=32_character_alpha_numeric_string
// 2. ?about
//****************************************************************************************************************
session_start();
$THIS_VERSION = "3.8";                                // Version of this file
$UPLOAD_ID = '';             
include_once('../../includes/db_inc.php');
                         // Initialize upload id
include_once($basefilepath.'uploader/ubr_ini.php');
require_once $basefilepath.'uploader/ubr_lib.php';
require_once $basefilepath.'uploader/ubr_finished_lib.php';
require_once $basefilepath.'classes/ado.php';
require_once $basefilepath.'classes/core.php';
require_once $basefilepath.'functions/general.php';
require_once $basefilepath.'classes/user.php';
if(!$objuser->isUserLoggedIn()){
	header("location:$siteName");
	exit();
}

if($_INI['php_error_reporting']){ error_reporting(0); }

header('Content-type: text/html; charset=UTF-8');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: '.date('r'));
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', FALSE);
header('Pragma: no-cache');

if(isset($_GET['upload_id']) && preg_match("/^[a-zA-Z0-9]{32}$/", $_GET['upload_id'])){ $UPLOAD_ID = $_GET['upload_id']; }
elseif(isset($_GET['about'])){ kak("<u><b>UBER UPLOADER FINISHED PAGE</b></u><br>UBER UPLOADER VERSION =  <b>" . $_INI['uber_version'] . "</b><br>UBR_FINISHED = <b>" . $THIS_VERSION . "<b><br>\n", 1 , __LINE__, $_INI['path_to_css_file']); }
else{ kak("<span class='ubrError'>ERROR</span>: Invalid parameters passed<br>", 1, __LINE__, $_INI['path_to_css_file']); }


//Declare local values
$_XML_DATA = array();                                          // Array of xml data read from the upload_id.redirect file
$_CONFIG_DATA = array();                                       // Array of config data read from the $_XML_DATA array
$_POST_DATA = array();                                         // Array of posted data read from the $_XML_DATA array
$_FILE_DATA = array();                                         // Array of 'FileInfo' objects read from the $_XML_DATA array
$_FILE_DATA_TABLE = '';                                        // String used to store file info results nested between <tr> tags
$_FILE_DATA_EMAIL = '';                                        // String used to store file info results

$xml_parser = new XML_Parser();                                  // XML parser
$xml_parser->setXMLFile($TEMP_DIR, $_GET['upload_id']);        // Set upload_id.redirect file
//$xml_parser->setXMLFileDelete($_INI['delete_redirect_file']);  // Delete upload_id.redirect file when finished parsing
$xml_parser->parseFeed();                                      // Parse upload_id.redirect file

// Display message if the XML parser encountered an error
if($xml_parser->getError()){ kak($xml_parser->getErrorMsg(), 1, __LINE__, $_INI['path_to_css_file']); }

$_XML_DATA = $xml_parser->getXMLData();                        // Get xml data from the xml parser
$_CONFIG_DATA = getConfigData($_XML_DATA);                     // Get config data from the xml data
$_POST_DATA  = getPostData($_XML_DATA);                        // Get post data from the xml data
$_FILE_DATA = getFileData($_XML_DATA);                         // Get file data from the xml data

// Output XML DATA, CONFIG DATA, POST DATA, FILE DATA to screen and exit if DEBUG_ENABLED.
if($_INI['debug_finished']){

	debug("<br><u>XML DATA</u>", $_XML_DATA);
	debug("<u>CONFIG DATA</u>", $_CONFIG_DATA);
	debug("<u>POST DATA</u>", $_POST_DATA);
	debug("<u>FILE DATA</u>", $_FILE_DATA);

	exit();
}


$counter = -1;
foreach($_FILE_DATA as $slot => $value)
{
	$counter++;
	$file_name = $_FILE_DATA[$slot]->getFileInfo('name');
	$extArr = explode(".",$file_name);
	$cntArr = count($extArr);
	$file_ext = $extArr[$cntArr-1];
	$rem = ".".$file_ext;
	$file_title = str_replace($rem, "", $file_name);
	$file_type = $_FILE_DATA[$slot]->getFileInfo('type');
	
	$fileSize = $_FILE_DATA[$slot]->getFileInfo('size');
	
	$file_ext_small = strtolower($file_ext);
	$userid = $_SESSION['user_id'];	
	$created_date = date('Y-m-d H:i:s');
	
	
	if(is_array($_POST_DATA['upcategory']))
		$category_id = $_POST_DATA['upcategory'][$counter];
	else
		$category_id = $_POST_DATA['upcategory'];
	if(is_array($_POST_DATA['uptitle']))	
		$file_title = $_POST_DATA['uptitle'][$counter];
	else
		$file_title = $_POST_DATA['uptitle'];	
		
	if(is_array($_POST_DATA['file_description']))	
		$file_description = $_POST_DATA['file_description'][$counter];
	else
		$file_description = $_POST_DATA['file_description'];		
	
	
	
	
	
	$file_path = clean($basefilepath.'uploads/user_files/');
	
	$time = md5(time());
	$new_file_name = $file_path.$time;
	rename($file_path.$file_name,$new_file_name);
	$file_code = $time;
  $sql = "INSERT INTO `file_uploader` set `file_name` ='$file_name', `file_mime_type` = '$file_type', `uploaded_by`='$userid', `file_ext_type`='$file_ext_small', `file_size` = '$fileSize', `file_path` = '$file_path', `created_date` = '$created_date' , `modified_date` = '$created_date', `file_title` = '$file_title', `category_id` = '$category_id', `file_description` = '$file_description', `file_code` = '$file_code', `status` = '1'"; 
	$ado->exec($sql);	
	
}
$core->setMessage('File Successfully Uploaded','1');
$core->redirect(getSiteLink('upload','uploaded_files'));
?>